#include <iostream>
#include <sys/time.h>
#include <omp.h>

using namespace std;

void generar(double *m,int n)
{
  int i,j;

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      m[i*n+j]=(double) (2*i+j);
    }
  }
}

void escribir(double *m,int n)
{
  int i,j;

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      cout << m[i*n+j]<< " ";
    }
    cout << endl;
  }
  cout << endl;
}

double prod_esc(int n,double *x,int incx,double *y,int incy)
{
  double s=0;

  for(int i=0;i<n;i++)  
    s+=x[incx*i]*y[incy*i];
  return s;
}

void vm(int n,double *x,int incx,double *m,double *y,int incy)
{
  for(int i=0;i<n;i++)
    y[i*incy]=prod_esc(n,x,incx,&m[i],n);
}

void mul_fil_omp(double *a,double *b,double *c,int n)
{
  int i;

#pragma omp parallel private(i)
{
   cout << " Thread "<< omp_get_thread_num() << " en zona paralela "<<endl;
#pragma omp single
{
   cout << " Thread "<< omp_get_thread_num() << " en region single "<<endl;
#pragma omp task
  {
    cout << " Thread "<< omp_get_thread_num() << " en tarea 0 "<<endl;
    for(i=0;i<n/2;i++)
    {
      vm(n,&a[i*n],1,b,&c[i*n],1);
    }
  }
#pragma omp task
  {
    cout << " Thread "<< omp_get_thread_num() << " en tarea 1 "<<endl;
    for(i=n/2;i<n;i++)
    {
      vm(n,&a[i*n],1,b,&c[i*n],1);
    }
  }
}
}
}

main()
{
  double *a,*b,*c;
  int n;
  struct timeval ti, tf;
  double tiempo;

  cin >> n;

  a=new double[n*n];
  b=new double[n*n];
  c=new double[n*n];

  generar(a,n);
  generar(b,n);

#ifdef DEBUG
  escribir(a,n);
  escribir(b,n);
#endif 
  gettimeofday(&ti, NULL);   // Instante inicial

  mul_fil_omp(a,b,c,n);

  gettimeofday(&tf, NULL);   // Instante final
  tiempo= (tf.tv_sec - ti.tv_sec)*1000000 + (tf.tv_usec - ti.tv_usec);
  cout << "  En " << tiempo/1000000 << " segundos" << endl;
#ifdef DEBUG
  escribir(c,n);
#endif 
  delete [] a;
  delete [] b;
  delete [] c;
}


























