#include <iostream>
#include <sys/time.h>
#include <stdlib.h>
#include <omp.h>

using namespace std;

void generar(int *d,int n)
{
  int i;

  for(i=0;i<n;i++)
  {
    d[i]=int((1.*rand()/RAND_MAX)*10);
  }
}

void escribir(int *d,int n)
{
  int i;

  for(i=0;i<n;i++)
  {
    cout << d[i]<< " ";
  }
  cout << endl;
}

void quicksort(int *d,int izq,int der,int n)
{
  int i,j,piv,t;

//#ifdef DEBUG
//  cout << "Al entrar: " << izq << " " << der << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
  if(izq>=der)
    return;
  else
  {
    i=izq+1;
    j=der;
    piv=d[izq];
    while(i<=j)
    {
      while(i<=der and d[i]<=piv)
        i++;
      while(d[j]>piv)
        j--;
      if(i<=der and j>i)
      {
        t=d[i];
        d[i]=d[j];
        d[j]=t;
//#ifdef DEBUG
//    cout << "Tras pivotar: ";
//  escribir(d,n);
//    cin >> t;
//#endif 
      }
    }  
    if(j>izq)
    {
      d[izq]=d[j];
      d[j]=piv;
//#ifdef DEBUG
//    cout << "Tras cambiar pivote: " << izq << " por " << j << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
    }
    quicksort(d,izq,j-1,n);
//#ifdef DEBUG
//    cout << "Tras ordenar " << izq << " " << j-1 << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
    quicksort(d,j+1,der,n);
//#ifdef DEBUG
//    cout << "Tras ordenar " << j+1 << " " << der << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif
  }
//#ifdef DEBUG
//  cout << "Al salir: " << izq << " " << der << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
}

void quicksort_omp(int *d,int izq,int der,int n,int nivel)
{
  int i,j,piv,t;

//#ifdef DEBUG
//  cout << "Al entrar: " << izq << " " << der << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
  if(izq>=der)
    return;
  else
  {
    i=izq+1;
    j=der;
    piv=d[izq];
    while(i<=j)
    {
      while(i<=der and d[i]<=piv)
        i++;
      while(d[j]>piv)
        j--;
      if(i<=der and j>i)
      {
        t=d[i];
        d[i]=d[j];
        d[j]=t;
//#ifdef DEBUG
//    cout << "Tras pivotar: ";
//  escribir(d,n);
//    cin >> t;
//#endif 
      }
    }  
    if(j>izq)
    {
      d[izq]=d[j];
      d[j]=piv;
//#ifdef DEBUG
//    cout << "Tras cambiar pivote: " << izq << " por " << j << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
    }
    if (nivel!=3)
    {
#pragma omp task
      {
        cout << " Nivel " << nivel << " tarea izquierda, thread " << omp_get_thread_num() << endl;
        quicksort_omp(d,izq,j-1,n,nivel+1);
      }
//#ifdef DEBUG
//    cout << "Tras ordenar " << izq << " " << j-1 << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
#pragma omp task
      {
        cout << " Nivel " << nivel << " tarea derecha, thread " << omp_get_thread_num() << endl;
        quicksort_omp(d,j+1,der,n,nivel+1);
      }
    }
    else
    {
      quicksort(d,izq,j-1,n);
//#ifdef DEBUG
//    cout << "Tras ordenar " << izq << " " << j-1 << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
      quicksort(d,j+1,der,n);
//#ifdef DEBUG
//    cout << "Tras ordenar " << j+1 << " " << der << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif
    } 
  }
//#ifdef DEBUG
//  cout << "Al salir: " << izq << " " << der << " : ";
//  escribir(d,n);
//    cin >> t;
//#endif 
}

main()
{
  int *d;
  int n;
  struct timeval ti, tf;
  double tiempo;

  cin >> n;

  d=new int[n];

  generar(d,n);

#ifdef DEBUG
  escribir(d,n);
#endif 
  gettimeofday(&ti, NULL);   // Instante inicial

#pragma omp parallel
{
#pragma omp single
  {
    cout << omp_get_num_threads() << endl;
    quicksort_omp(d,0,n-1,n,1);
  }
}

  gettimeofday(&tf, NULL);   // Instante final
  tiempo= (tf.tv_sec - ti.tv_sec)*1000000 + (tf.tv_usec - ti.tv_usec);
  cout << "  En " << tiempo/1000000 << " segundos" << endl;
#ifdef DEBUG
  escribir(d,n);
#endif 
  delete [] d;
}


























